apiVersion: apps/v1
kind: Deployment
metadata:
    name: micro-deployment
spec:
    replicas: 3
    selector:
        matchLabels:
            app: microservice
    template:
        metadata:
            labels:
                app: microservice
        spec:
            containers: 
                - name: microservice
                  image: hchauvel/microservice:latest
                  ports:
                    - containerPort: 5000
---
apiVersion: v1
kind: Service
metadata:
    name: microservice
spec:
    type: ClusterIP
    selector:
        app: microservice
    ports:
        - name: http
          port: 80
          protocol: TCP
          targetPort: 5000
---

apiVersion: networking.k8s.io/v1beta1
kind: Ingress
metadata:
    name: gate-ingress
    namespace: default
    annotations:
        kubernetes.io/ingress.class: nginx
        nginx.ingress.kubernetes.io/rewrite-target: /$2
        nginx.ingress.kubernetes.io/client-body-buffer-size: "1m"
        nginx.ingress.kubernetes.io/proxy-buffer-size: "64k" 
        nginx.ingress.kubernetes.io/ssl-redirect: "false"
        nginx.ingress.kubernetes.io/from-to-www-redirect: "false"
spec:
    rules:
        - http:
            paths:
                - backend:
                    serviceName: nginx-service
                    servicePort: 80
                  path: /nginx(/|$)(.*)
                - backend:
                    serviceName: apache-service
                    servicePort: 80
                  path: /apache(/|$)(.*)
                - backend:
                    serviceName: microservice
                    servicePort: 80
                  path: /micro(/|$)(.*)
